package com.bomostory.sceneeditmodule

import android.content.DialogInterface
import android.graphics.*
import android.net.Uri
import android.support.v7.app.AppCompatActivity
import android.os.Bundle
import android.os.Environment
import android.os.Handler
import android.support.v4.app.DialogFragment
import android.util.Log
import android.view.View
import android.widget.CompoundButton
import android.widget.SeekBar
import com.bomostory.sceneeditmodule.basicdata.*
import com.bomostory.sceneeditmodule.utils.MoviePlayer
import com.bomostory.sceneeditmodule.utils.MusicPlayer
import com.bomostory.sceneeditmodule.view.AudioTrackGroupView
import com.bomostory.sceneeditmodule.view.MovieSelectView
import com.example.tfat.myapplication.R
import com.google.gson.Gson
import io.reactivex.Observable
import io.reactivex.schedulers.Schedulers
import kotlinx.android.synthetic.main.activity_movie_edit.*
import com.example.exportmedia.MediaHelper
import com.example.exportmedia.data.AudioSource
import com.example.exportmedia.vedio.MovieMaker
import java.io.File
import java.util.AbstractMap
import kotlin.math.pow


class MovieEditActivity : AppCompatActivity(),
        DialogInterface.OnDismissListener,
        MusicSelectFragment.OnFragmentInteractionListener,
        MusicEditDialog.OnFragmentInteractionListener {

    override fun onFragmentInteraction(uri: Uri) {
        TODO("not implemented") //To change body of created functions use File | Settings | File Templates.
    }

    override fun onDismiss(dialog: DialogInterface?) {
        musicPlayer.stop()
        musicPlayer.release()

        delayedHide(100)
    }

    override fun onMusicPlayClick(path: String) {
        musicPlayer.pause()
        musicPlayer.clear()
        musicPlayer.add(path)
        musicPlayer.play()
    }

    override fun onMusicPauseClick() {
        musicPlayer.pause()
    }

    override fun onMusicImportClick(music: Music) {
        musics.add(music)
        moviePlayer.init()
        music.path?.let {
            moviePlayer.addMusic(it)
        }
        movieEditView.musics = musics

        val dialogFragment = supportFragmentManager.findFragmentByTag(MUSIC_SELECT_DIALOG_TAG) as DialogFragment
        dialogFragment.dismiss()
    }

    private val mHideHandler = Handler()
    private val mHidePart2Runnable = Runnable {
        window.decorView.systemUiVisibility =
                View.SYSTEM_UI_FLAG_LOW_PROFILE or
                View.SYSTEM_UI_FLAG_FULLSCREEN or
                View.SYSTEM_UI_FLAG_LAYOUT_STABLE or
                View.SYSTEM_UI_FLAG_IMMERSIVE_STICKY or
                View.SYSTEM_UI_FLAG_LAYOUT_HIDE_NAVIGATION or
                View.SYSTEM_UI_FLAG_HIDE_NAVIGATION
    }
    private val mShowPart2Runnable = Runnable {
        supportActionBar?.show()
    }
    private val mHideRunnable = Runnable {
        hide()
    }

    private var project: Project? = null
        set(value) {
            field = value
            value?.let {
                it.story?.let {
                    val story = Gson().fromJson<Story>("{\"scenes\":[{\"backgroundName\":\"s1\",\"backgroundPath\":\"/storage/emulated/0/Android/yuheng/Sample Theme/asset/public/scene/s1/scene_sample01_large.png\",\"layers\":[{\"actors\":[{\"isMoveable\":false,\"isSelect\":false,\"parentLayerIndex\":0,\"positionX\":235,\"positionY\":63,\"positionZ\":0,\"resourcePath\":\"/storage/emulated/0/Android/yuheng/Sample Theme/asset/public/actor/bat/act1/actor_bat_p1_small.png\",\"sideHeight\":200,\"sideLength\":200},{\"isMoveable\":false,\"isSelect\":false,\"parentLayerIndex\":0,\"positionX\":458,\"positionY\":203,\"positionZ\":1,\"resourcePath\":\"/storage/emulated/0/Android/yuheng/Sample Theme/asset/public/actor/bat/act1/actor_bat_p1_small.png\",\"sideHeight\":200,\"sideLength\":200}],\"id\":0},{\"actors\":[{\"isMoveable\":false,\"isSelect\":false,\"parentLayerIndex\":1,\"positionX\":1382,\"positionY\":487,\"positionZ\":0,\"resourcePath\":\"/storage/emulated/0/Android/yuheng/Sample Theme/asset/public/actor/cat_black/act1/actor_catblack_p2_small.png\",\"sideHeight\":200,\"sideLength\":200},{\"isMoveable\":false,\"isSelect\":false,\"parentLayerIndex\":1,\"positionX\":1406,\"positionY\":314,\"positionZ\":1,\"resourcePath\":\"/storage/emulated/0/Android/yuheng/Sample Theme/asset/public/actor/cat_black/act1/actor_catblack_p2_small.png\",\"sideHeight\":200,\"sideLength\":200},{\"isMoveable\":false,\"isSelect\":false,\"parentLayerIndex\":1,\"positionX\":695,\"positionY\":807,\"positionZ\":2,\"resourcePath\":\"/storage/emulated/0/Android/yuheng/Sample Theme/asset/public/actor/ant/act1/actor_ant_p1_small.png\",\"sideHeight\":200,\"sideLength\":200}],\"id\":1},{\"actors\":[{\"isMoveable\":false,\"isSelect\":false,\"parentLayerIndex\":2,\"positionX\":862,\"positionY\":539,\"positionZ\":0,\"resourcePath\":\"/storage/emulated/0/Android/yuheng/Sample Theme/asset/public/actor/ant/act1/actor_ant_p1_small.png\",\"sideHeight\":200,\"sideLength\":200},{\"isMoveable\":false,\"isSelect\":false,\"parentLayerIndex\":2,\"positionX\":941,\"positionY\":600,\"positionZ\":1,\"resourcePath\":\"/storage/emulated/0/Android/yuheng/Sample Theme/asset/public/actor/ant/act1/actor_ant_p1_small.png\",\"sideHeight\":200,\"sideLength\":200}],\"id\":2},{\"actors\":[],\"id\":3},{\"actors\":[],\"id\":4}],\"record\":{\"period\":8366,\"tracks\":[{\"positionX\":0,\"time\":1552},{\"positionX\":0,\"time\":1565},{\"positionX\":0,\"time\":1585},{\"positionX\":-20,\"time\":1600},{\"positionX\":-28,\"time\":1618},{\"positionX\":-45,\"time\":1637},{\"positionX\":-60,\"time\":1653},{\"positionX\":-77,\"time\":1671},{\"positionX\":-94,\"time\":1687},{\"positionX\":-112,\"time\":1703},{\"positionX\":-132,\"time\":1720},{\"positionX\":-152,\"time\":1736},{\"positionX\":-171,\"time\":1754},{\"positionX\":-193,\"time\":1770},{\"positionX\":-214,\"time\":1787},{\"positionX\":-230,\"time\":1804},{\"positionX\":-248,\"time\":1820},{\"positionX\":-266,\"time\":1837},{\"positionX\":-283,\"time\":1854},{\"positionX\":-300,\"time\":1869},{\"positionX\":-316,\"time\":1887},{\"positionX\":-330,\"time\":1904},{\"positionX\":-346,\"time\":1920},{\"positionX\":-361,\"time\":1937},{\"positionX\":-375,\"time\":1953},{\"positionX\":-388,\"time\":1970},{\"positionX\":-402,\"time\":1987},{\"positionX\":-414,\"time\":2003},{\"positionX\":-425,\"time\":2019},{\"positionX\":-435,\"time\":2037},{\"positionX\":-445,\"time\":2053},{\"positionX\":-454,\"time\":2070},{\"positionX\":-464,\"time\":2087},{\"positionX\":-472,\"time\":2104},{\"positionX\":-481,\"time\":2120},{\"positionX\":-489,\"time\":2136},{\"positionX\":-495,\"time\":2153},{\"positionX\":-501,\"time\":2171},{\"positionX\":-505,\"time\":2187},{\"positionX\":-509,\"time\":2203},{\"positionX\":-511,\"time\":2220},{\"positionX\":-513,\"time\":2237},{\"positionX\":-514,\"time\":2254},{\"positionX\":-514,\"time\":2271},{\"positionX\":-514,\"time\":2286},{\"positionX\":-514,\"time\":2303},{\"positionX\":-512,\"time\":2320},{\"positionX\":-506,\"time\":2337},{\"positionX\":-495,\"time\":2354},{\"positionX\":-482,\"time\":2371},{\"positionX\":-468,\"time\":2387},{\"positionX\":-453,\"time\":2405},{\"positionX\":-437,\"time\":2420},{\"positionX\":-421,\"time\":2437},{\"positionX\":-405,\"time\":2454},{\"positionX\":-386,\"time\":2470},{\"positionX\":-371,\"time\":2488},{\"positionX\":-353,\"time\":2504},{\"positionX\":-334,\"time\":2522},{\"positionX\":-318,\"time\":2538},{\"positionX\":-302,\"time\":2555},{\"positionX\":-283,\"time\":2574},{\"positionX\":-266,\"time\":2587},{\"positionX\":-249,\"time\":2604},{\"positionX\":-230,\"time\":2622},{\"positionX\":-212,\"time\":2641},{\"positionX\":-195,\"time\":2655},{\"positionX\":-175,\"time\":2674},{\"positionX\":-157,\"time\":2688},{\"positionX\":-142,\"time\":2706},{\"positionX\":-123,\"time\":2721},{\"positionX\":-105,\"time\":2739},{\"positionX\":-90,\"time\":2756},{\"positionX\":-76,\"time\":2772},{\"positionX\":-61,\"time\":2789},{\"positionX\":-49,\"time\":2805},{\"positionX\":-37,\"time\":2822},{\"positionX\":-25,\"time\":2839},{\"positionX\":-11,\"time\":2856},{\"positionX\":0,\"time\":2872},{\"positionX\":8,\"time\":2889},{\"positionX\":17,\"time\":2905},{\"positionX\":26,\"time\":2922},{\"positionX\":34,\"time\":2940},{\"positionX\":45,\"time\":2955},{\"positionX\":54,\"time\":2973},{\"positionX\":60,\"time\":2990},{\"positionX\":67,\"time\":3006},{\"positionX\":72,\"time\":3022},{\"positionX\":79,\"time\":3040},{\"positionX\":84,\"time\":3057},{\"positionX\":89,\"time\":3073},{\"positionX\":92,\"time\":3089},{\"positionX\":96,\"time\":3106},{\"positionX\":101,\"time\":3123},{\"positionX\":105,\"time\":3140},{\"positionX\":109,\"time\":3157},{\"positionX\":113,\"time\":3173},{\"positionX\":115,\"time\":3190},{\"positionX\":117,\"time\":3206},{\"positionX\":119,\"time\":3222},{\"positionX\":121,\"time\":3239},{\"positionX\":123,\"time\":3256},{\"positionX\":125,\"time\":3273},{\"positionX\":127,\"time\":3290},{\"positionX\":129,\"time\":3306},{\"positionX\":131,\"time\":3324},{\"positionX\":133,\"time\":3340},{\"positionX\":135,\"time\":3356},{\"positionX\":137,\"time\":3373},{\"positionX\":139,\"time\":3390},{\"positionX\":140,\"time\":3407},{\"positionX\":141,\"time\":3424},{\"positionX\":142,\"time\":3440},{\"positionX\":143,\"time\":3456},{\"positionX\":143,\"time\":3473},{\"positionX\":144,\"time\":3490},{\"positionX\":144,\"time\":3507},{\"positionX\":147,\"time\":3523},{\"positionX\":149,\"time\":3541},{\"positionX\":152,\"time\":3559},{\"positionX\":154,\"time\":3576},{\"positionX\":157,\"time\":3592},{\"positionX\":160,\"time\":3639},{\"positionX\":172,\"time\":3657},{\"positionX\":176,\"time\":3675},{\"positionX\":178,\"time\":3685},{\"positionX\":0,\"time\":4192},{\"positionX\":0,\"time\":4208},{\"positionX\":0,\"time\":4225},{\"positionX\":0,\"time\":4242},{\"positionX\":7,\"time\":4258},{\"positionX\":37,\"time\":4276},{\"positionX\":70,\"time\":4293},{\"positionX\":107,\"time\":4310},{\"positionX\":149,\"time\":4325},{\"positionX\":192,\"time\":4343},{\"positionX\":240,\"time\":4359},{\"positionX\":288,\"time\":4376},{\"positionX\":341,\"time\":4393},{\"positionX\":393,\"time\":4411},{\"positionX\":442,\"time\":4426},{\"positionX\":489,\"time\":4442},{\"positionX\":527,\"time\":4460},{\"positionX\":564,\"time\":4476},{\"positionX\":603,\"time\":4493},{\"positionX\":633,\"time\":4509},{\"positionX\":662,\"time\":4525},{\"positionX\":686,\"time\":4543},{\"positionX\":712,\"time\":4559},{\"positionX\":733,\"time\":4577},{\"positionX\":746,\"time\":4593},{\"positionX\":755,\"time\":4609},{\"positionX\":757,\"time\":4627},{\"positionX\":758,\"time\":4644},{\"positionX\":758,\"time\":4660},{\"positionX\":754,\"time\":4676},{\"positionX\":730,\"time\":4693},{\"positionX\":700,\"time\":4710},{\"positionX\":665,\"time\":4727},{\"positionX\":627,\"time\":4744},{\"positionX\":587,\"time\":4761},{\"positionX\":548,\"time\":4777},{\"positionX\":511,\"time\":4793},{\"positionX\":475,\"time\":4810},{\"positionX\":440,\"time\":4826},{\"positionX\":410,\"time\":4843},{\"positionX\":379,\"time\":4861},{\"positionX\":355,\"time\":4878},{\"positionX\":336,\"time\":4893},{\"positionX\":326,\"time\":4910},{\"positionX\":321,\"time\":4928},{\"positionX\":319,\"time\":4943},{\"positionX\":318,\"time\":4960},{\"positionX\":325,\"time\":4978},{\"positionX\":344,\"time\":4994},{\"positionX\":372,\"time\":5010},{\"positionX\":402,\"time\":5028},{\"positionX\":438,\"time\":5044},{\"positionX\":474,\"time\":5060},{\"positionX\":511,\"time\":5077},{\"positionX\":552,\"time\":5094},{\"positionX\":589,\"time\":5110},{\"positionX\":622,\"time\":5128},{\"positionX\":657,\"time\":5144},{\"positionX\":690,\"time\":5162},{\"positionX\":725,\"time\":5178},{\"positionX\":758,\"time\":5195},{\"positionX\":787,\"time\":5212},{\"positionX\":815,\"time\":5227},{\"positionX\":837,\"time\":5244},{\"positionX\":858,\"time\":5261},{\"positionX\":875,\"time\":5279},{\"positionX\":891,\"time\":5294},{\"positionX\":903,\"time\":5312},{\"positionX\":913,\"time\":5328},{\"positionX\":921,\"time\":5346},{\"positionX\":927,\"time\":5361},{\"positionX\":930,\"time\":5379},{\"positionX\":932,\"time\":5396},{\"positionX\":933,\"time\":5412},{\"positionX\":933,\"time\":5429},{\"positionX\":933,\"time\":5444},{\"positionX\":933,\"time\":5461},{\"positionX\":931,\"time\":5478},{\"positionX\":924,\"time\":5495},{\"positionX\":909,\"time\":5513},{\"positionX\":892,\"time\":5529},{\"positionX\":871,\"time\":5546},{\"positionX\":849,\"time\":5563},{\"positionX\":824,\"time\":5579},{\"positionX\":797,\"time\":5596},{\"positionX\":770,\"time\":5613},{\"positionX\":740,\"time\":5630},{\"positionX\":710,\"time\":5646},{\"positionX\":682,\"time\":5663},{\"positionX\":651,\"time\":5680},{\"positionX\":626,\"time\":5695},{\"positionX\":593,\"time\":5712},{\"positionX\":567,\"time\":5730},{\"positionX\":537,\"time\":5746},{\"positionX\":506,\"time\":5763},{\"positionX\":483,\"time\":5779},{\"positionX\":459,\"time\":5796},{\"positionX\":436,\"time\":5812},{\"positionX\":415,\"time\":5829},{\"positionX\":394,\"time\":5847},{\"positionX\":375,\"time\":5863},{\"positionX\":356,\"time\":5880},{\"positionX\":340,\"time\":5897},{\"positionX\":323,\"time\":5912},{\"positionX\":307,\"time\":5929},{\"positionX\":294,\"time\":5947},{\"positionX\":281,\"time\":5964},{\"positionX\":268,\"time\":5980},{\"positionX\":254,\"time\":5996},{\"positionX\":243,\"time\":6014},{\"positionX\":231,\"time\":6030},{\"positionX\":219,\"time\":6046},{\"positionX\":210,\"time\":6064},{\"positionX\":200,\"time\":6081},{\"positionX\":191,\"time\":6098},{\"positionX\":183,\"time\":6113},{\"positionX\":175,\"time\":6130},{\"positionX\":167,\"time\":6146},{\"positionX\":161,\"time\":6163},{\"positionX\":154,\"time\":6181},{\"positionX\":147,\"time\":6196},{\"positionX\":140,\"time\":6213},{\"positionX\":135,\"time\":6230},{\"positionX\":130,\"time\":6246},{\"positionX\":124,\"time\":6264},{\"positionX\":119,\"time\":6281},{\"positionX\":115,\"time\":6298},{\"positionX\":111,\"time\":6313},{\"positionX\":107,\"time\":6331},{\"positionX\":104,\"time\":6348},{\"positionX\":102,\"time\":6364},{\"positionX\":99,\"time\":6380},{\"positionX\":96,\"time\":6398},{\"positionX\":93,\"time\":6414},{\"positionX\":92,\"time\":6430},{\"positionX\":90,\"time\":6447},{\"positionX\":88,\"time\":6465},{\"positionX\":86,\"time\":6480},{\"positionX\":84,\"time\":6498},{\"positionX\":82,\"time\":6514},{\"positionX\":82,\"time\":6531},{\"positionX\":82,\"time\":6547},{\"positionX\":82,\"time\":6564},{\"positionX\":82,\"time\":6581}]}}]}", Story::class.java)
//                    movieEditView.story = it
//                    scene = it.scenes[0]
                    movieEditView.story = story
                    scene = story.scenes[0]
                }
            }
        }

    private var scene: Scene? = null
        set(value) {
            field = value
            value?.let {
                movieView.scene = value
                movieEditView.scene = value
                moviePlayer.scene = value
            }
        }

    private var isLoop = false
        set(value) {
            field = value
            movieEditView.isLoop = value
        }

    private var currentAudioPosition = 0
        set(value) {
            field = value
            movieEditView.currentAudioPosition = value
        }


    private val moviePlayer = MoviePlayer()

    private val musicPlayer = MusicPlayer()

    private val musics = ArrayList<Music>()

    private val mediaHelper = MediaHelper()

    companion object {
        const val PROJECT_KEY = "project_key"
        const val MUSIC_SELECT_DIALOG_TAG = "music_select_dialog_tag"
        const val MUSIC_EDIT_DIALOG_TAG = "music_edit_dialog_tag"
        const val FPS: Int = 30
        private const val UI_ANIMATION_DELAY = 300
    }

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_movie_edit)

        supportActionBar?.setDisplayHomeAsUpEnabled(true)

        project = Gson().fromJson<Project>(intent.extras.getString(PROJECT_KEY), Project::class.java)

        movieEditView.onPlayClickListener = View.OnClickListener(this::playMovie)
        movieEditView.onPauseClickListener = View.OnClickListener(this::pauseMovie)
        movieEditView.onAddMusicClickListener = View.OnClickListener(this::addMusic)
        movieEditView.onEditMusicClickListener = View.OnClickListener(this::editMusic)
        movieEditView.onDeleteMusicClickListener = View.OnClickListener(this::deleteMusic)
        movieEditView.onSaveMovieClickListener = View.OnClickListener(this::saveMovie)
        movieEditView.onSeekBarChangeListener = object : SeekBar.OnSeekBarChangeListener {
            override fun onProgressChanged(seekBar: SeekBar?, progress: Int, fromUser: Boolean) {
                if (fromUser) {
                    moviePlayer.seekTo(progress)
                }
            }

            override fun onStartTrackingTouch(seekBar: SeekBar?) {
            }

            override fun onStopTrackingTouch(seekBar: SeekBar?) {
            }
        }
        movieEditView.onMovieSelectListener = object : MovieSelectView.OnMovieSelectListener {
            override fun onMoveSelect(scene: Scene) {
                this@MovieEditActivity.scene = scene
            }
        }
        movieEditView.onAudioTrackSelectListener = object : AudioTrackGroupView.OnAudioTrackSelectListener {
            override fun onAudioTrackSelect(position: Int) {
                currentAudioPosition = position
            }
        }
        movieEditView.onAudioTrackScrollListener = object : AudioTrackGroupView.OnAudioTrackScrollListener {
            override fun onAudioTrackScroll(position: Int, scrollRatio: Double) {
                scene?.record?.period?.let {
                    musics[position].offsetTime = (it * scrollRatio).toLong()
                }
            }
        }
        movieEditView.onLoopSwitchChangedListener = CompoundButton.OnCheckedChangeListener { _, isChecked ->
            isLoop = isChecked
        }

        moviePlayer.moviePlayListener = object : MoviePlayer.OnMoviePlayListener {
            override fun onMoviePlayComplete() {
                movieEditView.isBtnPanelEnable = true
            }

            override fun onMoviePlayViewUpdate(x: Int) {
                movieView.x = x
            }

            override fun onMoviePlayTimeUpdate(time: Long) {
                movieEditView.playTime = time
            }
        }

        mediaHelper.init(this)
    }

    override fun onPostCreate(savedInstanceState: Bundle?) {
        super.onPostCreate(savedInstanceState)
        delayedHide(100)
    }

    private fun delayedHide(delayMillis: Int) {
        mHideHandler.removeCallbacks(mHideRunnable)
        mHideHandler.postDelayed(mHideRunnable, delayMillis.toLong())
    }

    private fun hide() {
        supportActionBar?.hide()
        mHideHandler.removeCallbacks(mShowPart2Runnable)
        mHideHandler.postDelayed(mHidePart2Runnable, UI_ANIMATION_DELAY.toLong())
    }

    private fun playMovie(view: View) {
        moviePlayer.play()
        movieEditView.isBtnPanelEnable = false
    }

    private fun pauseMovie(view: View) {
        moviePlayer.pause()
        movieEditView.isBtnPanelEnable = true
    }

    private fun addMusic(view: View) {
        val libraryPaths = ArrayList<String>()

        project?.let {
            val assetFolder = it.assetFolder.path
            it.themeAssetIndex.contains.music.values.forEach {
                libraryPaths.add("$assetFolder/$it")
            }
        }

        val musicSource = DataParser.parseMusicSource(contentResolver, libraryPaths)
        val musicSelectDialog = MusicSelectDialog.newInstance(Gson().toJson(musicSource))
        musicSelectDialog.show(supportFragmentManager, MUSIC_SELECT_DIALOG_TAG)
    }

    private fun editMusic(view: View) {
        Log.d("Debug", "edit music track $currentAudioPosition")

        val musicEditDialog = MusicEditDialog.newInstance("", "")
        musicEditDialog.show(supportFragmentManager, MUSIC_EDIT_DIALOG_TAG)
    }

    private fun deleteMusic(view: View) {
        if (currentAudioPosition in 0 until musics.size) {
            moviePlayer.init()
            musics[currentAudioPosition].path?.let {
                moviePlayer.removeMusic(it)
            }

            musics.removeAt(currentAudioPosition)

            movieEditView.musics = musics
        }
    }

    private fun saveMovie(view: View) {
        val inputSceneStatus = LinkedHashMap<Int, Int>()
        var sceneIndex = -1
        var sceneRepeatCount = 0

        val movieBuilder = MovieMaker.Builder(mediaHelper)
        movieBuilder.fps = FPS
        movieBuilder.audioSources = generateAudioSource()
        generateMovieFilms()
                .subscribeOn(Schedulers.io())
                .subscribe({
                    if (it.key == sceneIndex) {
                        sceneRepeatCount++
                    } else {
                        sceneIndex = it.key
                        sceneRepeatCount = 1
                        movieBuilder.addImage(it.key, it.value).subscribe()
                    }
                    inputSceneStatus[sceneIndex] = sceneRepeatCount
                }, {

                }, {
                    movieBuilder.addInputFile(inputSceneStatus).subscribe({
                        movieBuilder.inputFilePath = it
                    }, {

                    }, {
                        val movieMaker = movieBuilder.build()
                        movieMaker.output(File(Environment.getExternalStorageDirectory(), "test.mp4")).subscribe()
                    })
                })
    }

    private fun generateAudioSource(): ArrayList<AudioSource> {
        val audioSources = ArrayList<AudioSource>()
        for (music in musics) {
            val audioSource = AudioSource()
            audioSource.duration = music.duration
            audioSource.offsetSec = music.offsetTime.toFloat() / 1000
            audioSource.path = music.path
            audioSources.add(audioSource)
        }
        return audioSources
    }

    private fun generateMovieFilms(): Observable<AbstractMap.SimpleEntry<Int, Bitmap>> {
        var preBitmap: Bitmap?
        return Observable.create<AbstractMap.SimpleEntry<Int, Bitmap>> {
            scene?.apply {
                record?.apply {
                    var bitmap = drawScene(0)
                    var trackPosition = -1
                    var isDrawNewScene: Boolean

                    for (t in 0..period step ((1f / FPS.toFloat()) * 1000).toLong()) {
                        isDrawNewScene = false

                        for (track in tracks) {
                            if (t >= track.time && tracks.indexOf(track) > trackPosition) {
                                isDrawNewScene = true

                                preBitmap = bitmap
                                preBitmap?.recycle()

                                bitmap = drawScene(track.positionX)
                                trackPosition = tracks.indexOf(track)

                                bitmap?.apply {
                                    it.onNext(AbstractMap.SimpleEntry(trackPosition + 1, this))
                                    Log.d("Debug", "Index: ${trackPosition + 1}  Time: $t")
                                }
                            }
                        }

                        bitmap?.apply {
                            if (!isDrawNewScene) {
                                it.onNext(AbstractMap.SimpleEntry(trackPosition + 1, this))
                                Log.d("Debug", "Index: ${trackPosition + 1}  Time: $t")
                            }
                        }
                    }
                    it.onComplete()
                }
            }
        }
    }

    private fun drawScene(trackX: Int): Bitmap? {
        var sceneBitmap: Bitmap? = null
        val scaledWidth = resources.getDimensionPixelSize(R.dimen.movie_width)
        val scaleHeight = resources.getDimensionPixelSize(R.dimen.movie_height)

        scene?.apply {
            sceneBitmap = BitmapFactory.decodeFile(backgroundPath)
            sceneBitmap = Bitmap.createScaledBitmap(sceneBitmap, scaledWidth, scaleHeight, true)

            val canvas = Canvas(sceneBitmap)
            for (layer in layers) {
                for (actor in layer.actors) {
                    var actorBitmap = BitmapFactory.decodeFile(actor.resourcePath)
                    actorBitmap = Bitmap.createScaledBitmap(actorBitmap, actor.sideLength, actor.sideLength, true)

                    canvas.save()
                    canvas.translate(trackX / 2f.pow(layers.indexOf(layer)), 0f)
                    canvas.drawBitmap(actorBitmap, actor.positionX.toFloat(), actor.positionY.toFloat(), Paint())
                    canvas.restore()

                    actorBitmap.recycle()
                }
            }
        }
        return sceneBitmap
    }
}